package com.sqx.modules.common.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sqx.common.utils.Result;
import com.sqx.modules.common.dao.CommonInfoDao;
import com.sqx.modules.common.entity.CommonInfo;
import com.sqx.modules.common.service.CommonInfoService;
import com.sqx.modules.course.service.CourseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author fang
 * @date 2020/7/8
 */
@CacheConfig(cacheNames = "common")
@Service
public class CommonInfoServiceImpl extends ServiceImpl<CommonInfoDao, CommonInfo> implements CommonInfoService {

    @Autowired
    private CommonInfoDao commonInfoDao;
    @Autowired
    private CourseService courseService;


    @CacheEvict(key = "#commonInfo.id")
    @Override
    public Result update(CommonInfo commonInfo) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date now = new Date();
        commonInfo.setCreateAt(sdf.format(now));
        if(commonInfo.getType()==820){
            Result result = courseService.setDyNotifyUrl(commonInfo.getValue());
            String code = String.valueOf(result.get("code"));
            if(!"0".equals(code)){
                return result;
            }
        }
        commonInfoDao.updateById(commonInfo);

        return Result.success();
    }

    @Override
    public CommonInfo findOne(int type) {
        return commonInfoDao.findOne(type);
    }

    @CacheEvict(key = "#id")
    @Override
    public Result delete(long id) {
        commonInfoDao.deleteById(id);
        return Result.success();
    }

    @CacheEvict(key = "#commonInfo.id")
    @Override
    public Result updateBody(CommonInfo commonInfo) {
        commonInfoDao.updateById(commonInfo);
        return Result.success();
    }

    @Override
    public Result findByType(Integer type) {
        return Result.success().put("data",commonInfoDao.findOne(type));
    }

    @Override
    public Result findByTypeAndCondition(String condition) {
        return Result.success().put("data",commonInfoDao.findByCondition(condition));
    }


}